aboutsummaryrefslogtreecommitdiffstats
path: root/validation-scripts
diff options
context:
space:
mode:
authorJenkins <jenkins@review.openstack.org>2015-09-17 12:22:56 +0000
committerGerrit Code Review <review@openstack.org>2015-09-17 12:22:56 +0000
commitd65027bd4a676e046157ba2729866166b9d6a584 (patch)
tree816d6b27c7fc7c6278d54c0b8679fcceac89f478 /validation-scripts
parent4a12edc59dc3b6b62c825329c60295fa6dd0c3da (diff)
parenta6861730bd3eee0cd419c959048cac9a48ee8482 (diff)
Merge "network validation to ping test each interface"
Diffstat (limited to 'validation-scripts')
-rw-r--r--validation-scripts/all-nodes.sh29
1 files changed, 29 insertions, 0 deletions
diff --git a/validation-scripts/all-nodes.sh b/validation-scripts/all-nodes.sh
new file mode 100644
index 00000000..38a5a55e
--- /dev/null
+++ b/validation-scripts/all-nodes.sh
@@ -0,0 +1,29 @@
+#!/bin/bash
+
+# For each unique remote IP (specified via Heat) we check to
+# see if one of the locally configured networks matches and if so we
+# attempt a ping test on that networks remote IP.
+function ping_controller_ips() {
+ local REMOTE_IPS=$1
+
+ for REMOTE_IP in $(echo $REMOTE_IPS | sed -e "s| |\n|g" | sort -u); do
+
+ for LOCAL_NETWORK in $(ip r | grep -v default | cut -d " " -f 1); do
+ local LOCAL_CIDR=$(echo $LOCAL_NETWORK | cut -d "/" -f 2)
+ local LOCAL_NETMASK=$(ipcalc -m $LOCAL_NETWORK | grep NETMASK | cut -d "=" -f 2)
+ local REMOTE_NETWORK=$(ipcalc -np $REMOTE_IP $LOCAL_NETMASK | grep NETWORK | cut -d "=" -f 2)
+
+ if [ $REMOTE_NETWORK/$LOCAL_CIDR == $LOCAL_NETWORK ]; then
+ echo -n "Trying to ping $REMOTE_IP for local network $LOCAL_NETWORK..."
+ if ! ping -c 1 $REMOTE_IP &> /dev/null; then
+ echo "FAILURE"
+ echo "$REMOTE_IP is not pingable. Local Network: $LOCAL_NETWORK" >&2
+ exit 1
+ fi
+ echo "SUCCESS"
+ fi
+ done
+ done
+}
+
+ping_controller_ips "$ping_test_ips"